<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/newcamera.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/newcamera.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2007 by Dariusz Dawidowski</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00008"></a>00008 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 <span class="comment"></span>
<a name="l00011"></a>00011 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">    Library General Public License for more details.</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00017"></a>00017 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00018"></a>00018 <span class="comment">    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</span>
<a name="l00019"></a>00019 <span class="comment">*/</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __CEL_PF_NEW_CAMERA__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_NEW_CAMERA__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/comp_8h.html">iutil/comp.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/eventh_8h.html">iutil/eventh.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/weakref_8h.html">csutil/weakref.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/weakrefarr_8h.html">csutil/weakrefarr.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/refarr_8h.html">csutil/refarr.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;physicallayer/propclas.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;physicallayer/propfact.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;physicallayer/facttmpl.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;celtool/stdpcimp.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;celtool/stdparams.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;celtool/camera.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;propclass/region.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;propclass/mesh.h&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00041"></a>00041 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObjectRegistry.html">iObjectRegistry</a>;
<a name="l00042"></a>00042 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiGraphics3D.html">iGraphics3D</a>;
<a name="l00043"></a>00043 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiEngine.html">iEngine</a>;
<a name="l00044"></a>00044 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiVirtualClock.html">iVirtualClock</a>;
<a name="l00045"></a>00045 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiKeyboardDriver.html">iKeyboardDriver</a>;
<a name="l00046"></a>00046 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMouseDriver.html">iMouseDriver</a>;
<a name="l00047"></a>00047 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCollideSystem.html">iCollideSystem</a>;
<a name="l00048"></a>00048 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiView.html">iView</a>;
<a name="l00049"></a>00049 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsView.html">csView</a>;
<a name="l00050"></a>00050 <span class="keyword">class </span>celPcNewCamera;
<a name="l00051"></a>00051 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsReversibleTransform.html">csReversibleTransform</a>;
<a name="l00052"></a>00052 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOrthoTransform.html">csOrthoTransform</a>;
<a name="l00053"></a>00053 <span class="keyword">struct </span><a class="code" href="structiPcZoneManager.html" title="This is the zone manager.">iPcZoneManager</a>;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">struct </span><a class="code" href="structiPcNewCamera.html" title="This is a camera property class.">iPcNewCamera</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="keyword">namespace </span>iPcmNewCamera
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">struct </span>General : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#ga711056cbf220f268640935926c404ba5">SCF_INTERFACE</a> (General, 0, 1, 0);
<a name="l00062"></a>00062 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetParentCamera (<a class="code" href="structiPcNewCamera.html" title="This is a camera property class.">iPcNewCamera</a>* camera) = 0;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use UseSpringOrigin () instead&quot;</span>)
<a name="l00075"></a>00075   virtual <span class="keywordtype">bool</span> UseSpringPos () const = 0;
<a name="l00076"></a>00076 
<a name="l00082"></a>00082   virtual <span class="keywordtype">bool</span> UseSpringOrigin () const = 0;
<a name="l00083"></a>00083 
<a name="l00089"></a>00089   virtual <span class="keywordtype">bool</span> UseSpringTarget () const = 0;
<a name="l00090"></a>00090 
<a name="l00096"></a>00096   virtual <span class="keywordtype">bool</span> UseSpringUp () const = 0;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   CS_DEPRECATED_METHOD_MSG(&quot;Use GetCollisionDetection () instead&quot;)
<a name="l00104"></a>00104   virtual <span class="keywordtype">bool</span> AllowCollisionDetection () const = 0;
<a name="l00105"></a>00105 
<a name="l00111"></a>00111   virtual <span class="keywordtype">bool</span> GetCollisionDetection () const = 0;
<a name="l00112"></a>00112 
<a name="l00118"></a>00118   virtual <span class="keywordtype">bool</span> DrawAttachedMesh () const = 0;
<a name="l00119"></a>00119 
<a name="l00124"></a>00124   virtual <span class="keywordtype">float</span> GetSpringCoefficient () const = 0;
<a name="l00125"></a>00125 
<a name="l00130"></a>00130   virtual <span class="keywordtype">void</span> SetSpringCoefficient (<span class="keywordtype">float</span> s) = 0;
<a name="l00131"></a>00131 
<a name="l00137"></a>00137   virtual <span class="keywordtype">void</span> SetOriginSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00138"></a>00138 
<a name="l00143"></a>00143   virtual <span class="keywordtype">float</span> GetOriginSpringCoefficient () const = 0;
<a name="l00144"></a>00144 
<a name="l00150"></a>00150   virtual <span class="keywordtype">void</span> SetTargetSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00151"></a>00151 
<a name="l00156"></a>00156   virtual <span class="keywordtype">float</span> GetTargetSpringCoefficient () const = 0;
<a name="l00157"></a>00157 
<a name="l00163"></a>00163   virtual <span class="keywordtype">void</span> SetUpSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00164"></a>00164 
<a name="l00169"></a>00169   virtual <span class="keywordtype">float</span> GetUpSpringCoefficient () const = 0;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   CS_DEPRECATED_METHOD_MSG(&quot;Use GetOrigin () instead&quot;)
<a name="l00176"></a>00176   virtual const <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetPosition () const = 0;
<a name="l00177"></a>00177 
<a name="l00182"></a>00182   virtual const <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetOrigin () const = 0;
<a name="l00183"></a>00183 
<a name="l00188"></a>00188   virtual const <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetTarget () const = 0;
<a name="l00189"></a>00189 
<a name="l00194"></a>00194   virtual const <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetUp () const = 0;
<a name="l00195"></a>00195 
<a name="l00201"></a>00201   virtual <span class="keywordtype">bool</span> DecideCameraState () = 0;
<a name="l00202"></a>00202 };
<a name="l00203"></a>00203 
<a name="l00213"></a><a class="code" href="structiPcmNewCamera_1_1Tracking.html">00213</a> struct <a class="code" href="structiPcmNewCamera_1_1Tracking.html" title="This is a camera to be used with actoranalog.">Tracking</a> : public virtual General
<a name="l00214"></a>00214 {
<a name="l00215"></a>00215   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#ga711056cbf220f268640935926c404ba5">SCF_INTERFACE</a> (<a class="code" href="structiPcmNewCamera_1_1Tracking.html" title="This is a camera to be used with actoranalog.">Tracking</a>, 0, 0, 1);
<a name="l00216"></a>00216 
<a name="l00221"></a>00221   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> ResetCamera () = 0;
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="keyword">enum</span> TargetState
<a name="l00224"></a>00224   {
<a name="l00225"></a>00225     TARGET_BASE = 0,
<a name="l00226"></a>00226     TARGET_OBJ,
<a name="l00227"></a>00227     TARGET_NONE
<a name="l00228"></a>00228   };
<a name="l00229"></a>00229 
<a name="l00234"></a>00234   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetTargetEntity (<span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00235"></a>00235 
<a name="l00242"></a>00242   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetState (TargetState targetstate) = 0;
<a name="l00243"></a>00243 
<a name="l00247"></a>00247   <span class="keyword">virtual</span> TargetState GetTargetState () = 0;
<a name="l00248"></a>00248 
<a name="l00253"></a>00253   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetYOffset (<span class="keywordtype">float</span> targetyoffset) = 0;
<a name="l00254"></a>00254 };
<a name="l00255"></a>00255 } <span class="comment">// iPcmNewCamera</span>
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="keyword">typedef</span> iPcmNewCamera::General iCelCameraMode;
<a name="l00258"></a>00258 
<a name="l00262"></a><a class="code" href="structiPcNewCamera.html">00262</a> <span class="keyword">struct </span><a class="code" href="structiPcNewCamera.html" title="This is a camera property class.">iPcNewCamera</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="code" href="structiPcCamera.html" title="The representation of a camera.">iPcCamera</a>
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#ga711056cbf220f268640935926c404ba5">SCF_INTERFACE</a> (<a class="code" href="structiPcNewCamera.html" title="This is a camera property class.">iPcNewCamera</a>, 0, 1, 0);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use GetBaseOrigin () instead&quot;</span>)
<a name="l00271"></a>00271   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetBasePos () <span class="keyword">const</span> = 0;
<a name="l00272"></a>00272 
<a name="l00277"></a>00277   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetBaseOrigin () <span class="keyword">const</span> = 0;
<a name="l00278"></a>00278 
<a name="l00283"></a>00283   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetBaseDir () <span class="keyword">const</span> = 0;
<a name="l00284"></a>00284 
<a name="l00289"></a>00289   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetBaseUp () <span class="keyword">const</span> = 0;
<a name="l00290"></a>00290 
<a name="l00295"></a>00295   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsReversibleTransform.html">csReversibleTransform</a>&amp; GetBaseTrans () <span class="keyword">const</span> = 0;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use GetOrigin () instead&quot;</span>)
<a name="l00302"></a>00302   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetPos () <span class="keyword">const</span> = 0;
<a name="l00303"></a>00303 
<a name="l00308"></a>00308   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetOrigin () <span class="keyword">const</span> = 0;
<a name="l00309"></a>00309 
<a name="l00314"></a>00314   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetTarget () <span class="keyword">const</span> = 0;
<a name="l00315"></a>00315 
<a name="l00320"></a>00320   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetUp () <span class="keyword">const</span> = 0;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use SetTargetPositionOffset () instead&quot;</span>)
<a name="l00328"></a>00328   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetPositionOffset (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; offset) = 0;
<a name="l00329"></a>00329 
<a name="l00336"></a>00336   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetPositionOffset (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; offset) = 0;
<a name="l00337"></a>00337 
<a name="l00341"></a>00341   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetMinimumOffset (<span class="keywordtype">float</span> minoff) = 0;
<a name="l00342"></a>00342 
<a name="l00349"></a>00349   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCameraPositionOffset (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; offset) = 0;
<a name="l00350"></a>00350 
<a name="l00356"></a>00356   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00357"></a>00357 
<a name="l00362"></a>00362   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetSpringCoefficient () <span class="keyword">const</span> = 0;
<a name="l00363"></a>00363 
<a name="l00369"></a>00369   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetOriginSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00370"></a>00370 
<a name="l00375"></a>00375   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetOriginSpringCoefficient () <span class="keyword">const</span> = 0;
<a name="l00376"></a>00376 
<a name="l00382"></a>00382   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00383"></a>00383 
<a name="l00388"></a>00388   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTargetSpringCoefficient () <span class="keyword">const</span> = 0;
<a name="l00389"></a>00389 
<a name="l00395"></a>00395   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetUpSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00396"></a>00396 
<a name="l00401"></a>00401   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetUpSpringCoefficient () <span class="keyword">const</span> = 0;
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use GetCollisionDetection () instead&quot;</span>)
<a name="l00409"></a>00409   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> DetectCollisions () <span class="keyword">const</span> = 0;
<a name="l00410"></a>00410 
<a name="l00416"></a>00416   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCollisionDetection (<span class="keywordtype">bool</span> detectCollisions) = 0;
<a name="l00417"></a>00417 
<a name="l00423"></a>00423   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetCollisionDetection () <span class="keyword">const</span> = 0;
<a name="l00424"></a>00424 
<a name="l00428"></a>00428   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCollisionYFocusOffset (<span class="keywordtype">float</span> yoff) = 0;
<a name="l00429"></a>00429 
<a name="l00433"></a>00433   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetCollisionYFocusOffset () <span class="keyword">const</span> = 0;
<a name="l00434"></a>00434 
<a name="l00443"></a>00443   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCollisionCorrection (<span class="keywordtype">float</span> corr) = 0;
<a name="l00444"></a>00444 
<a name="l00448"></a>00448   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetCollisionCorrection () <span class="keyword">const</span> = 0;
<a name="l00449"></a>00449 
<a name="l00455"></a>00455   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCollisionAvoidanceRadiusSq (<span class="keywordtype">float</span> radsq) = 0;
<a name="l00456"></a>00456 
<a name="l00460"></a>00460   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetCollisionAvoidanceRadiusSq () <span class="keyword">const</span> = 0;
<a name="l00461"></a>00461 
<a name="l00466"></a>00466   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCollisionYAvoidance (<span class="keywordtype">float</span> yavoid) = 0;
<a name="l00467"></a>00467 
<a name="l00471"></a>00471   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetCollisionYAvoidance () <span class="keyword">const</span> = 0;
<a name="l00472"></a>00472 
<a name="l00477"></a>00477   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCollisionAvoidanceInterpolation (<span class="keywordtype">float</span> aint) = 0;
<a name="l00478"></a>00478 
<a name="l00482"></a>00482   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetCollisionAvoidanceInterpolation () <span class="keyword">const</span> = 0;
<a name="l00483"></a>00483 
<a name="l00488"></a>00488   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Non existant. Use the new collision detection system.&quot;</span>)
<a name="l00489"></a>00489   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetCollisionSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00490"></a>00490 
<a name="l00495"></a>00495   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Non existant. Use the new collision detection system.&quot;</span>)
<a name="l00496"></a>00496   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetCollisionSpringCoefficient () <span class="keyword">const</span> = 0;
<a name="l00497"></a>00497 
<a name="l00503"></a>00503   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> InCameraTransition () <span class="keyword">const</span> = 0;
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use SetTransitionTime (float) instead.&quot;</span>)
<a name="l00511"></a>00511   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTransitionSpringCoefficient (<span class="keywordtype">float</span> springCoef) = 0;
<a name="l00512"></a>00512 
<a name="l00513"></a>00513   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use SetTransitionTime (float) instead.&quot;</span>)
<a name="l00519"></a>00519   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTransitionSpringCoefficient () <span class="keyword">const</span> = 0;
<a name="l00520"></a>00520 
<a name="l00521"></a>00521   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use GetTransitionTime () instead.&quot;</span>)
<a name="l00531"></a>00531   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTransitionCutoffDistance (<span class="keywordtype">float</span> cutOffOriginDist,
<a name="l00532"></a>00532         <span class="keywordtype">float</span> cutOffTargetDist) = 0;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use GetTransitionTime () instead.&quot;</span>)
<a name="l00540"></a>00540   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTransitionCutoffPosDistance () <span class="keyword">const</span> = 0;
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use GetTransitionTime () instead.&quot;</span>)
<a name="l00548"></a>00548   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTransitionCutoffOriginDistance () <span class="keyword">const</span> = 0;
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#a69b27a22db26f4a2bb7a26a85d2ab06b">CS_DEPRECATED_METHOD_MSG</a>(<span class="stringliteral">&quot;Use GetTransitionTime () instead.&quot;</span>)
<a name="l00556"></a>00556   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTransitionCutoffTargetDistance () <span class="keyword">const</span> = 0;
<a name="l00557"></a>00557 
<a name="l00562"></a>00562   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTransitionTime (<span class="keywordtype">float</span> time) = 0;
<a name="l00563"></a>00563 
<a name="l00567"></a>00567   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTransitionTime () <span class="keyword">const</span> = 0;
<a name="l00568"></a>00568 
<a name="l00574"></a>00574   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> AttachCameraMode (iCelCameraMode* mode) = 0;
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="keyword">enum</span> CEL_CAMERA_MODE
<a name="l00577"></a>00577   {
<a name="l00578"></a>00578     CCM_FIRST_PERSON = 0,
<a name="l00579"></a>00579     CCM_THIRD_PERSON,
<a name="l00580"></a>00580     CCM_TRACKING,
<a name="l00581"></a>00581     CCM_HORIZONTAL,
<a name="l00582"></a>00582     CCM_ISOMETRIC,
<a name="l00583"></a>00583     CCM_COUNT
<a name="l00584"></a>00584   };
<a name="l00585"></a>00585 
<a name="l00591"></a>00591   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> AttachCameraMode (CEL_CAMERA_MODE modetype) = 0;
<a name="l00592"></a>00592 
<a name="l00597"></a>00597   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> GetCurrentCameraModeIndex () <span class="keyword">const</span> = 0;
<a name="l00598"></a>00598 
<a name="l00603"></a>00603   <span class="keyword">virtual</span> iCelCameraMode* GetCurrentCameraMode () = 0;
<a name="l00604"></a>00604 
<a name="l00610"></a>00610   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetCurrentCameraMode (<span class="keywordtype">size_t</span> modeIndex) = 0;
<a name="l00611"></a>00611 
<a name="l00615"></a>00615   <span class="keyword">virtual</span> <span class="keywordtype">void</span> NextCameraMode () = 0;
<a name="l00616"></a>00616 
<a name="l00620"></a>00620   <span class="keyword">virtual</span> <span class="keywordtype">void</span> PrevCameraMode () = 0;
<a name="l00621"></a>00621 
<a name="l00625"></a>00625   <span class="keyword">virtual</span> <span class="keywordtype">void</span> Draw () = 0;
<a name="l00626"></a>00626 
<a name="l00632"></a>00632   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOrthoTransform.html">csOrthoTransform</a> &amp;GetTransform () = 0;
<a name="l00633"></a>00633 
<a name="l00639"></a>00639   <span class="keyword">virtual</span> iCelCameraMode* GetCameraMode (<span class="keywordtype">int</span> idx = -1) = 0;
<a name="l00640"></a>00640 
<a name="l00648"></a>00648   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00649"></a><a class="code" href="structiPcNewCamera.html#a9b32042ddfc5ba593bb02bc4203fd2d3">00649</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;T&gt;</a> QueryModeInterface (<span class="keywordtype">int</span> idx = -1)
<a name="l00650"></a>00650   {
<a name="l00651"></a>00651     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* cmode = GetCameraMode (idx);
<a name="l00652"></a>00652     <span class="keywordflow">if</span> (!cmode)
<a name="l00653"></a>00653       <span class="keywordflow">return</span> 0;
<a name="l00654"></a>00654     <span class="keywordflow">return</span> scfQueryInterface&lt;T&gt; (cmode);
<a name="l00655"></a>00655   }
<a name="l00656"></a>00656 
<a name="l00660"></a>00660   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__meshplugins.html#ga7694729a241497f51dce86c01ba2577f">Reset</a> () = 0;
<a name="l00661"></a>00661 };
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 <span class="preprocessor">#endif // __CEL_PF_NEW_CAMERA__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
